diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/doc/tgax-voip-traffic.inc ns-3.47/src/applications/doc/tgax-voip-traffic.inc
--- ns-3.46/src/applications/doc/tgax-voip-traffic.inc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/applications/doc/tgax-voip-traffic.inc	2026-02-16 16:08:49.569229800 -0800
@@ -0,0 +1,266 @@
+VoIP Traffic Model
+------------------
+
+This section describes the implementation of the |ns3| VoIP traffic generator model, which
+is based on the IEEE 802.11-14/0571r12 TGAX evaluation methodology [TGAX_EVAL]_. The model
+generates realistic voice-over-IP (VoIP) traffic patterns suitable for evaluating IEEE 802.11
+networks and other wireless systems.
+
+The VoIP traffic model is implemented in the ``src/applications/`` folder.
+
+The VoIP traffic generator models the behavior of a real VoIP source, producing traffic
+that alternates between periods of active talking and silence. This model is useful for
+simulating realistic VoIP scenarios in network simulations, particularly for evaluating
+the performance of wireless access technologies such as IEEE 802.11 (Wi-Fi).
+
+The model implements a two-state Markov chain to represent voice activity, where transitions
+occur between active (talking) and inactive (silence) states. During active states, the source
+generates packets at regular intervals (20 ms) with one payload size, and during silence states,
+packets are generated at longer intervals (160 ms) with a smaller payload size. Both states
+can last for exponentially distributed durations, giving the model stochastic properties that
+match real voice traffic characteristics.
+
+The VoIP model can be used with various socket types including IPv4/UDP, IPv6/UDP, and
+PacketSocket, making it flexible for different network configurations and simulation scenarios.
+
+Scope and Limitations
+~~~~~~~~~~~~~~~~~~~~~
+
+The VoIP model implements the core traffic generation aspects of the IEEE 802.11-14/0571r12
+specification. The following describes what is covered and what is not:
+
+**Supported Features:**
+
+- Two-state Markov model for voice activity (active/inactive states)
+- Configurable state transition probabilities
+- Exponential distribution for state durations
+- Variable packet payload sizes for active and inactive states
+- Laplacian distribution for downlink packet delay jitter
+- Integration with UDP, TCP, and PacketSocket protocols
+- Comprehensive trace sources for monitoring packet transmission and state changes
+
+**Known Limitations:**
+
+- Protocol header overhead (3 bytes for IPv4, 5 bytes for IPv6-- both values assuming IP header compression (not implemented in ns-3) is used) must be added to payload sizes
+- Jitter is applied uniformly to all packets (asymmetric uplink/downlink jitter not differentiated)
+- TCP transmission does not validate buffer availability; packets may be dropped if the TX buffer is full
+- The model does not enforce the implicit 12.2 kbps bit rate constraint in the IEEE document; users must configure appropriate parameters
+- Directional traffic (unidirectional source only, no bidirectional conversation modeling)
+
+Model Description
+~~~~~~~~~~~~~~~~~
+
+The ``TgaxVoipTraffic`` application is a source application that generates VoIP traffic patterns
+according to the IEEE 802.11-14/0571r12 evaluation methodology. The application uses a simple
+but effective two-state Markov model to generate realistic voice activity patterns.
+
+**State Machine:**
+
+The model maintains two states:
+
+* **ACTIVE_TALKING**: The source is actively transmitting voice data. In this state, packets
+  are generated at the voice encoder interval (default 20 ms) with a payload size configured
+  for active voice packets (default 33 bytes).
+
+* **INACTIVE_SILENCE**: The source is in a silent period. In this state, packets are generated
+  at the silence encoder interval (default 160 ms) with a smaller payload size (default 7 bytes).
+  Silence packets typically carry comfort noise or silence indication in real VoIP systems.
+
+**State Transitions:**
+
+The transition from one state to another follows a two-state Markov chain with configurable
+transition probabilities:
+
+* **VoiceToSilenceProbability** (default 0.016): Probability per state update interval to transition
+  from ACTIVE_TALKING to INACTIVE_SILENCE.
+
+* **SilenceToVoiceProbability** (default 0.016): Probability per state update interval to transition
+  from INACTIVE_SILENCE to ACTIVE_TALKING.
+
+With default parameters (both probabilities at 0.016), the model produces a voice activity factor
+of approximately 50%, meaning the source is in the active state about half the time.
+
+**State Duration:**
+
+Once a state is entered, the source remains in that state for an exponentially distributed duration:
+
+* **MeanActiveStateDuration** (default 1250 ms): Mean duration of active talking periods.
+* **MeanInactiveStateDuration** (default 1250 ms): Mean duration of silence periods.
+
+These exponential distributions produce realistic variability in conversation patterns, where some
+active periods are very short and others are quite long.
+
+**Packet Generation and Jitter:**
+
+Packets are generated at regular intervals determined by the current state (20 ms for active,
+160 ms for silence). Each generated packet receives a random delay jitter before transmission,
+drawn from a Laplacian distribution:
+
+* **MeanDelayJitter** (default 0 us): Mean of the Laplacian distribution.
+* **ScaleDelayJitter** (default 5110 us): Scale parameter of the Laplacian distribution.
+* **BoundDelayJitter** (default 80 ms): Bound on the jitter magnitude to ensure stability.
+
+The jitter model is applied only in the downlink direction, as specified in the IEEE 802.11-14/0571r12
+methodology.
+
+**Payload Sizes and Protocol Headers:**
+
+The model specifies default payload sizes based on the IEEE specification:
+
+* **ActivePacketPayloadSize** (default 33 bytes): Size of packets during active talking.
+* **SilencePacketPayloadSize** (default 7 bytes): Size of packets during silence periods.
+
+When using UDP over IPv4 or IPv6, users should account for compressed protocol headers:
+- IPv4 with compression: add 3 bytes to each payload size
+- IPv6 with compression: add 5 bytes to each payload size
+
+These header sizes are NOT automatically included; the user must adjust the payload size
+attributes accordingly if protocol header compression is desired in the simulation.
+
+Configuration and Usage
+***********************
+
+The VoIP traffic generator is instantiated as an application through the ``ApplicationHelper``.
+Here is a basic example using IPv4/UDP:
+
+::
+
+  // Create nodes
+  NodeContainer nodes;
+  nodes.Create(2);
+
+  // Install Internet stack and assign IP addresses
+  InternetStackHelper internet;
+  internet.Install(nodes);
+
+  Ipv4AddressHelper ipv4;
+  ipv4.SetBase("10.0.0.0", "255.255.255.0");
+  ipv4.Assign(devices);
+
+  // Configure VoIP application
+  ApplicationHelper sourceHelper(TgaxVoipTraffic::GetTypeId());
+  sourceHelper.SetAttribute("Protocol", StringValue("ns3::UdpSocketFactory"));
+  sourceHelper.SetAttribute("Remote", AddressValue(InetSocketAddress(Ipv4Address("10.0.0.2"), 5000)));
+  sourceHelper.SetAttribute("ActivePacketPayloadSize", UintegerValue(33 + 3)); // +3 for IPv4 header
+  sourceHelper.SetAttribute("SilencePacketPayloadSize", UintegerValue(7 + 3));
+
+  auto sourceApps = sourceHelper.Install(nodes.Get(0));
+  sourceApps.Start(Seconds(1.0));
+  sourceApps.Stop(Seconds(11.0));
+
+  // Create receiver
+  PacketSinkHelper sinkHelper("ns3::UdpSocketFactory", InetSocketAddress(Ipv4Address::GetAny(), 5000));
+  auto sinkApps = sinkHelper.Install(nodes.Get(1));
+  sinkApps.Start(Seconds(0.0));
+  sinkApps.Stop(Seconds(12.0));
+
+Attributes
+~~~~~~~~~~
+
+The VoIP traffic generator supports multiple socket types through the ``Protocol`` attribute:
+
+* **ns3::UdpSocketFactory**: UDP socket (recommended for most scenarios)
+* **ns3::TcpSocketFactory**: TCP socket (may experience packet drops if TX buffer is full)
+* **ns3::PacketSocketFactory**: Raw packet socket (useful for link-layer only simulations)
+
+For each socket type, the ``Remote`` address must be configured appropriately:
+
+* For UDP/TCP: Use ``InetSocketAddress`` for IPv4 or ``Inet6SocketAddress`` for IPv6
+* For PacketSocket: Use ``PacketSocketAddress`` with physical layer addressing
+
+The following additional attributes control the behavior of the VoIP traffic generator:
+
+**Protocol Configuration:**
+
+* ``Protocol``: The socket factory type to use. Default: ``ns3::PacketSocketFactory``
+* ``Remote``: The remote address and port for the VoIP destination
+
+**Packet Sizes:**
+
+* ``ActivePacketPayloadSize``: Payload size (in bytes) for packets during active talking states. Default: 33
+* ``SilencePacketPayloadSize``: Payload size (in bytes) for packets during silence states. Default: 7
+
+**State Machine Parameters:**
+
+* ``MeanActiveStateDuration``: Mean duration (Time) of active talking states. Default: 1250 ms
+* ``MeanInactiveStateDuration``: Mean duration (Time) of silence states. Default: 1250 ms
+* ``VoiceToSilenceProbability``: Transition probability from active to silence state per state update. Default: 0.016
+* ``SilenceToVoiceProbability``: Transition probability from silence to active state per state update. Default: 0.016
+
+**Encoder Parameters:**
+
+* ``VoiceEncoderInterval``: Time interval between generation of active voice packets. Default: 20 ms
+* ``SilenceEncoderInterval``: Time interval between generation of silence packets. Default: 160 ms
+
+**Jitter Model:**
+
+* ``MeanDelayJitter``: Mean of the Laplacian distribution for packet delay jitter. Default: 0 us
+* ``ScaleDelayJitter``: Scale parameter of the Laplacian distribution for jitter. Default: 5110 us
+* ``BoundDelayJitter``: Upper bound on the magnitude of applied jitter. Default: 80 ms
+
+Trace Sources
+~~~~~~~~~~~~~
+
+The VoIP traffic generator provides two main trace sources for monitoring simulation behavior:
+
+**TxWithJitter:**
+
+::
+
+  typedef void (*TxTracedCallback)(Ptr<const Packet> packet, Time jitter);
+
+This trace source is fired when a packet is transmitted. It provides both the packet being
+transmitted and the jitter value that was applied to that packet. This is useful for analyzing
+packet transmission patterns and the distribution of applied jitter.
+
+**StateUpdate:**
+
+::
+
+  typedef void (*StateUpdatedCallback)(VoiceActivityState state, Time duration);
+
+This trace source is fired when the voice activity state changes (from active to silence or vice versa).
+It provides the new state and the expected duration of that state. This is useful for analyzing voice
+activity patterns and verifying that the Markov model is producing the expected statistics.
+
+Examples
+~~~~~~~~
+
+The ``voip-example.cc`` program demonstrates basic usage of the VoIP traffic generator.
+This example sets up a simple two-node Wi-Fi network (AP and STA) with VoIP traffic flowing
+from the STA to the AP. The example supports three socket type configurations: IPv4/UDP,
+IPv6/UDP, and PacketSocket.
+
+Tests
+~~~~~
+
+Unit tests for the VoIP traffic model are provided in ``src/applications/test/tgax-voip-traffic-test-suite.cc``.
+These tests verify:
+
+* Correct packet sizes for active and silence states
+* Proper encoder frame intervals (20 ms for active, 160 ms for silence)
+* State duration statistics matching exponential distribution expectations
+* State transition correctness
+* Proper application of jitter to packets
+* Voice activity factor statistics matching theoretical expectations
+
+To run the VoIP traffic tests:
+
+::
+
+  $ ./test.py -s tgax-voip-traffic
+
+Verification
+~~~~~~~~~~~~
+
+The VoIP traffic model has been checked against the IEEE 802.11-14/0571r12 specification
+by comparing:
+
+* Default parameter values against those specified in the standard
+* Observed state durations against exponential distribution properties
+* Voice activity factor (ratio of active to total time) against theoretical expectations
+* Packet sizes and intervals against specification
+
+The test suite demonstrates that the model correctly implements the two-state Markov behavior,
+produces appropriate state durations, and generates traffic patterns consistent with real VoIP systems.
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/examples/CMakeLists.txt ns-3.47/src/applications/examples/CMakeLists.txt
--- ns-3.46/src/applications/examples/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/examples/CMakeLists.txt	2026-02-16 16:08:49.569229800 -0800
@@ -7,3 +7,47 @@
     ${libinternet}
     ${libnetwork}
 )
+
+build_lib_example(
+  NAME tgax-video-example
+  SOURCE_FILES tgax-video-example.cc
+  LIBRARIES_TO_LINK
+    ${libapplications}
+    ${libwifi}
+    ${libmobility}
+    ${libinternet}
+    ${libnetwork}
+)
+
+build_lib_example(
+  NAME tgax-voip-example
+  SOURCE_FILES tgax-voip-example.cc
+  LIBRARIES_TO_LINK
+    ${libapplications}
+    ${libwifi}
+    ${libmobility}
+    ${libinternet}
+    ${libnetwork}
+)
+
+build_lib_example(
+  NAME tgax-virtual-desktop-example
+  SOURCE_FILES tgax-virtual-desktop-example.cc
+  LIBRARIES_TO_LINK
+    ${libapplications}
+    ${libwifi}
+    ${libmobility}
+    ${libinternet}
+    ${libnetwork}
+)
+
+build_lib_example(
+  NAME rta-tig-mobile-gaming-example
+  SOURCE_FILES rta-tig-mobile-gaming-example.cc
+  LIBRARIES_TO_LINK
+    ${libapplications}
+    ${libwifi}
+    ${libmobility}
+    ${libinternet}
+    ${libnetwork}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/examples/rta-tig-mobile-gaming-example.cc ns-3.47/src/applications/examples/rta-tig-mobile-gaming-example.cc
--- ns-3.46/src/applications/examples/rta-tig-mobile-gaming-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/applications/examples/rta-tig-mobile-gaming-example.cc	2026-02-16 16:08:49.569229800 -0800
@@ -0,0 +1,353 @@
+/*
+ * Copyright (c) 2005,2006,2007 INRIA
+ * Copyright (c) 2016 Magister Solutions
+ * Copyright (c) 2025 Tom Henderson
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Borrows from examples/wireless/wifi-ap.cc for overall Wi-Fi network setup pattern
+ * Borrows from src/applications/examples/three-gpp-http-example.cc for overall simulation flow
+ */
+
+/**
+ * @file rta-tig-mobile-gaming-example.cc
+ * @brief A simple real-time mobile gaming traffic generator example over Wi-Fi
+ *
+ * This example demonstrates how to set up a basic ns-3 simulation with real-time
+ * mobile gaming traffic over a Wi-Fi network. Real-time mobile gaming is characterized
+ * by small packets (30-500 bytes) sent frequently (every 30-60ms) with low latency
+ * requirements.
+ *
+ * The simulation consists of:
+ * - A simple Wi-Fi network with one AP (Access Point) and one STA (Station)
+ * - Gaming traffic with three stages: Initial, Gaming, and Ending
+ * - Application-level tracing to observe gaming packets and stage transitions
+ *
+ * The traffic model follows IEEE 802.11-18/2009r6 RTA TIG Report (Section 4.1.4):
+ * - Two synchronization mechanisms: Status Sync and Frame Lockstep Sync
+ * - Packet sizes and arrivals follow Largest Extreme Value distribution
+ * - Initial and end packets follow Uniform distribution
+ *
+ * Traffic model presets:
+ * - Status Sync DL: a=13ms, b=3.7ms arrivals; a=50, b=11 bytes sizes
+ * - Status Sync UL: a=15ms, b=5.7ms arrivals; a=38, b=3.7 bytes sizes
+ * - Lockstep DL: a=28ms, b=4.2ms arrivals; a=210, b=35 bytes sizes
+ * - Lockstep UL: a=22ms, b=3.4ms arrivals; a=92, b=38 bytes sizes
+ *
+ * To run with default (status-sync DL): ./ns3 run rta-tig-mobile-gaming-example
+ * To run status-sync UL: ./ns3 run "rta-tig-mobile-gaming-example --model=status-sync-ul"
+ * To run lockstep DL: ./ns3 run "rta-tig-mobile-gaming-example --model=lockstep-dl"
+ * To run lockstep UL: ./ns3 run "rta-tig-mobile-gaming-example --model=lockstep-ul"
+ *
+ * To disable verbose logging: ./ns3 run "rta-tig-mobile-gaming-example --verbose=false"
+ */
+
+#include "ns3/applications-module.h"
+#include "ns3/core-module.h"
+#include "ns3/internet-module.h"
+#include "ns3/mobility-module.h"
+#include "ns3/network-module.h"
+#include "ns3/wifi-module.h"
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("RtaTigMobileGamingExample");
+
+/**
+ * Callback invoked when a gaming packet is transmitted
+ * @param context The context string
+ * @param packet The transmitted packet
+ * @param stage The traffic model stage
+ */
+void GamingPacketSent(std::string context,
+                      Ptr<const Packet> packet,
+                      RtaTigMobileGaming::TrafficModelStage stage);
+
+/**
+ * Callback invoked when the PacketSink receives a packet
+ * @param context The context string
+ * @param packet The received packet
+ * @param address The sender's address
+ */
+void PacketReceived(std::string context, Ptr<const Packet> packet, const Address& address);
+
+int
+main(int argc, char* argv[])
+{
+    Time duration{Seconds(10)};          // Simulation time in seconds
+    std::string model{"status-sync-dl"}; // Traffic model preset
+    bool verbose = true;                 // Enable/disable verbose logging
+
+    CommandLine cmd(__FILE__);
+    cmd.Usage("Real-time mobile gaming traffic example");
+    cmd.AddValue("duration", "Duration of traffic flow, in seconds", duration);
+    cmd.AddValue("model",
+                 "Traffic model preset (status-sync-dl, status-sync-ul, lockstep-dl, lockstep-ul). "
+                 "Default: status-sync-dl",
+                 model);
+    cmd.AddValue("verbose",
+                 "Enable verbose logging of RtaTigMobileGaming, PacketSink, and this program",
+                 verbose);
+    cmd.Parse(argc, argv);
+
+    if (verbose)
+    {
+        LogComponentEnable(
+            "RtaTigMobileGamingExample",
+            (LogLevel)(LOG_PREFIX_FUNC | LOG_PREFIX_NODE | LOG_PREFIX_TIME | LOG_LEVEL_ALL));
+        LogComponentEnable(
+            "RtaTigMobileGaming",
+            (LogLevel)(LOG_PREFIX_FUNC | LOG_PREFIX_NODE | LOG_PREFIX_TIME | LOG_LEVEL_INFO));
+        LogComponentEnable(
+            "PacketSink",
+            (LogLevel)(LOG_PREFIX_FUNC | LOG_PREFIX_NODE | LOG_PREFIX_TIME | LOG_LEVEL_INFO));
+    }
+
+    NodeContainer wifiNodes;
+    wifiNodes.Create(2); // Create 2 nodes: one will be AP, one will be STA
+
+    Ptr<Node> apNode = wifiNodes.Get(0);
+    Ptr<Node> staNode = wifiNodes.Get(1);
+
+    YansWifiChannelHelper channel = YansWifiChannelHelper::Default();
+    YansWifiPhyHelper phy;
+    phy.SetChannel(channel.Create());
+
+    WifiMacHelper mac;
+    WifiHelper wifi;
+    wifi.SetStandard(WIFI_STANDARD_80211ax);
+
+    NetDeviceContainer apDevices;
+    NetDeviceContainer staDevices;
+
+    // Configure AP
+    Ssid ssid = Ssid("gaming-network");
+    mac.SetType("ns3::ApWifiMac", "Ssid", SsidValue(ssid));
+    apDevices = wifi.Install(phy, mac, apNode);
+
+    // Configure STA
+    mac.SetType("ns3::StaWifiMac", "Ssid", SsidValue(ssid));
+    staDevices = wifi.Install(phy, mac, staNode);
+
+    MobilityHelper mobility;
+    mobility.SetPositionAllocator("ns3::GridPositionAllocator",
+                                  "MinX",
+                                  DoubleValue(0.0),
+                                  "MinY",
+                                  DoubleValue(0.0),
+                                  "DeltaX",
+                                  DoubleValue(5.0),
+                                  "DeltaY",
+                                  DoubleValue(5.0),
+                                  "GridWidth",
+                                  UintegerValue(2),
+                                  "LayoutType",
+                                  StringValue("RowFirst"));
+    mobility.SetMobilityModel("ns3::ConstantPositionMobilityModel");
+    mobility.Install(wifiNodes);
+
+    InternetStackHelper internet;
+    internet.Install(wifiNodes);
+
+    Ipv4AddressHelper ipv4;
+    ipv4.SetBase("10.1.1.0", "255.255.255.0");
+
+    NetDeviceContainer allDevices;
+    allDevices.Add(apDevices);
+    allDevices.Add(staDevices);
+    Ipv4InterfaceContainer ipv4Interfaces = ipv4.Assign(allDevices);
+
+    NS_LOG_INFO("AP address: " << ipv4Interfaces.GetAddress(0));
+    NS_LOG_INFO("STA address: " << ipv4Interfaces.GetAddress(1));
+
+    // Gaming uses UDP as specified
+    std::string protocolFactory = "ns3::UdpSocketFactory";
+    uint16_t port = 5000;
+
+    ApplicationHelper sourceHelper(RtaTigMobileGaming::GetTypeId());
+    sourceHelper.SetAttribute("Protocol", TypeIdValue(TypeId::LookupByName(protocolFactory)));
+
+    // Configure traffic model parameters based on preset
+    // Parameters from IEEE 802.11-18/2009r6 Tables 4-3 and 4-4
+    Ptr<Node> sourceNode;
+    Ptr<Node> sinkNode;
+    std::string remoteAddress;
+
+    if (model == "status-sync-dl")
+    {
+        // Downlink: AP -> STA
+        sourceNode = apNode;
+        sinkNode = staNode;
+        remoteAddress = "10.1.1.2";
+
+        // Status-sync DL parameters (defaults)
+        // Initial: [0, 20], End: [500, 600]
+        // Arrivals: LEV(13ms, 3.7ms), Sizes: LEV(50, 11)
+        NS_LOG_INFO("Using Status-Sync Downlink model (default parameters)");
+    }
+    else if (model == "status-sync-ul")
+    {
+        // Uplink: STA -> AP
+        sourceNode = staNode;
+        sinkNode = apNode;
+        remoteAddress = "10.1.1.1";
+
+        // Status-sync UL parameters
+        auto ips = CreateObjectWithAttributes<UniformRandomVariable>("Min",
+                                                                     DoubleValue(0),
+                                                                     "Max",
+                                                                     DoubleValue(20));
+        sourceHelper.SetAttribute("InitialPacketSize", PointerValue(ips));
+
+        auto eps = CreateObjectWithAttributes<UniformRandomVariable>("Min",
+                                                                     DoubleValue(400),
+                                                                     "Max",
+                                                                     DoubleValue(550));
+        sourceHelper.SetAttribute("EndPacketSize", PointerValue(eps));
+
+        auto pal = CreateObjectWithAttributes<LargestExtremeValueRandomVariable>(
+            "Location",
+            DoubleValue(15000), // 15ms in us
+            "Scale",
+            DoubleValue(5700)); // 5.7ms in us
+        sourceHelper.SetAttribute("PacketArrivalLev", PointerValue(pal));
+
+        auto psl = CreateObjectWithAttributes<LargestExtremeValueRandomVariable>("Location",
+                                                                                 DoubleValue(38),
+                                                                                 "Scale",
+                                                                                 DoubleValue(3.7));
+        sourceHelper.SetAttribute("PacketSizeLev", PointerValue(psl));
+
+        NS_LOG_INFO("Using Status-Sync Uplink model");
+    }
+    else if (model == "lockstep-dl")
+    {
+        // Downlink: AP -> STA
+        sourceNode = apNode;
+        sinkNode = staNode;
+        remoteAddress = "10.1.1.2";
+
+        // Lockstep DL parameters
+        auto ips = CreateObjectWithAttributes<UniformRandomVariable>("Min",
+                                                                     DoubleValue(0),
+                                                                     "Max",
+                                                                     DoubleValue(80));
+        sourceHelper.SetAttribute("InitialPacketSize", PointerValue(ips));
+
+        auto eps = CreateObjectWithAttributes<UniformRandomVariable>("Min",
+                                                                     DoubleValue(1400),
+                                                                     "Max",
+                                                                     DoubleValue(1500));
+        sourceHelper.SetAttribute("EndPacketSize", PointerValue(eps));
+
+        auto pal = CreateObjectWithAttributes<LargestExtremeValueRandomVariable>(
+            "Location",
+            DoubleValue(28000), // 28ms in us
+            "Scale",
+            DoubleValue(4200)); // 4.2ms in us
+        sourceHelper.SetAttribute("PacketArrivalLev", PointerValue(pal));
+
+        auto psl = CreateObjectWithAttributes<LargestExtremeValueRandomVariable>("Location",
+                                                                                 DoubleValue(210),
+                                                                                 "Scale",
+                                                                                 DoubleValue(35));
+        sourceHelper.SetAttribute("PacketSizeLev", PointerValue(psl));
+
+        NS_LOG_INFO("Using Frame Lockstep Downlink model");
+    }
+    else if (model == "lockstep-ul")
+    {
+        // Uplink: STA -> AP
+        sourceNode = staNode;
+        sinkNode = apNode;
+        remoteAddress = "10.1.1.1";
+
+        // Lockstep UL parameters
+        auto ips = CreateObjectWithAttributes<UniformRandomVariable>("Min",
+                                                                     DoubleValue(0),
+                                                                     "Max",
+                                                                     DoubleValue(80));
+        sourceHelper.SetAttribute("InitialPacketSize", PointerValue(ips));
+
+        auto eps = CreateObjectWithAttributes<UniformRandomVariable>("Min",
+                                                                     DoubleValue(500),
+                                                                     "Max",
+                                                                     DoubleValue(600));
+        sourceHelper.SetAttribute("EndPacketSize", PointerValue(eps));
+
+        auto pal = CreateObjectWithAttributes<LargestExtremeValueRandomVariable>(
+            "Location",
+            DoubleValue(22000), // 22ms in us
+            "Scale",
+            DoubleValue(3400)); // 3.4ms in us
+        sourceHelper.SetAttribute("PacketArrivalLev", PointerValue(pal));
+
+        auto psl = CreateObjectWithAttributes<LargestExtremeValueRandomVariable>("Location",
+                                                                                 DoubleValue(92),
+                                                                                 "Scale",
+                                                                                 DoubleValue(38));
+        sourceHelper.SetAttribute("PacketSizeLev", PointerValue(psl));
+
+        NS_LOG_INFO("Using Frame Lockstep Uplink model");
+    }
+    else
+    {
+        NS_FATAL_ERROR(
+            "Invalid model: "
+            << model
+            << ". Use 'status-sync-dl', 'status-sync-ul', 'lockstep-dl', or 'lockstep-ul'.");
+    }
+
+    Address remoteAddr = InetSocketAddress(Ipv4Address(remoteAddress.c_str()), port);
+    sourceHelper.SetAttribute("Remote", AddressValue(remoteAddr));
+
+    auto sourceApps = sourceHelper.Install(sourceNode);
+    sourceApps.Start(Seconds(1.0));
+    sourceApps.Stop(Seconds(1.0) + duration);
+
+    PacketSinkHelper sinkHelper(protocolFactory, InetSocketAddress(Ipv4Address::GetAny(), port));
+    auto sinkApps = sinkHelper.Install(sinkNode);
+    sinkApps.Start(Seconds(0.0));
+    sinkApps.Stop(Seconds(2.0) + duration);
+
+    // Connect to gaming TX with stage trace
+    Config::Connect("/NodeList/*/ApplicationList/*/$ns3::RtaTigMobileGaming/TxWithStage",
+                    MakeCallback(&GamingPacketSent));
+
+    // Connect to RX trace
+    Config::Connect("/NodeList/*/ApplicationList/*/$ns3::PacketSink/Rx",
+                    MakeCallback(&PacketReceived));
+
+    NS_LOG_INFO("Starting simulation for traffic duration: " << duration.As(Time::S));
+    NS_LOG_INFO("Traffic model: " << model);
+
+    Simulator::Stop(Seconds(2) + duration);
+    Simulator::Run();
+
+    // Get statistics from packet sink
+    Ptr<PacketSink> sink = DynamicCast<PacketSink>(sinkApps.Get(0));
+    if (sink)
+    {
+        uint32_t bytesRx = sink->GetTotalRx();
+        NS_LOG_INFO("Total bytes received: " << bytesRx);
+    }
+
+    Simulator::Destroy();
+
+    return 0;
+}
+
+void
+GamingPacketSent(std::string context,
+                 Ptr<const Packet> packet,
+                 RtaTigMobileGaming::TrafficModelStage stage)
+{
+    NS_LOG_INFO("Gaming TX [" << context << "]: Packet size (bytes): " << packet->GetSize()
+                              << " Stage: " << stage);
+}
+
+void
+PacketReceived(std::string context, Ptr<const Packet> packet, const Address& address)
+{
+    NS_LOG_INFO("Packet RX [" << context << "]: Size(bytes): " << packet->GetSize());
+}
